diff -r -u lib/libc_r/uthread/uthread_fork.c lib.patched/libc_r/uthread/uthread_fork.c
--- lib/libc_r/uthread/uthread_fork.c	Fri Dec 10 09:06:45 2004
+++ lib.patched/libc_r/uthread/uthread_fork.c	Thu Mar  3 14:50:06 2005
@@ -68,8 +68,15 @@
 			af->prepare();
 	}
 
+	extern spinlock_t *__malloc_lock;
+	if (__isthreaded && __malloc_lock != NULL)
+		_SPINLOCK(__malloc_lock);
+
 	/* Fork a new process: */
 	if ((ret = __sys_fork()) != 0) {
+		if (__isthreaded && __malloc_lock != NULL)
+			_SPINUNLOCK(__malloc_lock);
+
 		/* Run down atfork parent handlers. */
 		TAILQ_FOREACH(af, &_atfork_list, qe) {
 			if (af->parent != NULL)
@@ -78,6 +85,9 @@
 		_pthread_mutex_unlock(&_atfork_mutex);
 
 	} else {
+		if (__isthreaded && __malloc_lock != NULL)
+			_SPINUNLOCK(__malloc_lock);
+
 		/* Close the pthread kernel pipe: */
 		__sys_close(_thread_kern_pipe[0]);
 		__sys_close(_thread_kern_pipe[1]);
